diff --git a/sys/dev/netif/re/re.c b/sys/dev/netif/re/re.c
index dfe6b3a706..16958e8335 100644
--- a/sys/dev/netif/re/re.c
+++ b/sys/dev/netif/re/re.c
@@ -16425,7 +22557,10 @@ static void re_hw_phy_config(struct re_softc *sc)
                 Data &= ~BIT_10;
                 MP_WritePhyUshort(sc, 0x10, Data);
                 MP_WritePhyUshort(sc, 0x1f, 0x0000);
-                MP_WritePhyUshort(sc, 0x00, 0x9200);
+        } else if (sc->re_type == MACFG_39) {
+                Data_u32 = re_eri_read(sc, 0x1D0, 4, ERIAR_ExGMAC);
+                Data_u32 &= ~BIT_1;
+                re_eri_write(sc, 0x1D0, 4, Data_u32, ERIAR_ExGMAC);
 
                 MP_WritePhyUshort(sc, 0x1F, 0x0005);
                 MP_WritePhyUshort(sc, 0x05, 0x8B80);
@@ -16434,11 +22569,20 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x06, Data);
                 MP_WritePhyUshort(sc, 0x1f, 0x0000);
 
-                MP_WritePhyUshort(sc, 0x1F, 0x0007);
-                MP_WritePhyUshort(sc, 0x1E, 0x002D);
+                MP_WritePhyUshort(sc, 0x1F, 0x0005);
+                MP_WritePhyUshort(sc, 0x05, 0x8B85);
+                Data = MP_ReadPhyUshort(sc, 0x06);
+                Data |= BIT_15;
+                MP_WritePhyUshort(sc, 0x06, Data);
+                MP_WritePhyUshort(sc, 0x1f, 0x0000);
+
+                MP_WritePhyUshort(sc, 0x1f, 0x0004);
+                MP_WritePhyUshort(sc, 0x1f, 0x0007);
+                MP_WritePhyUshort(sc, 0x1e, 0x002D);
                 Data = MP_ReadPhyUshort(sc, 0x18);
                 Data |= BIT_4;
                 MP_WritePhyUshort(sc, 0x18, Data);
+                MP_WritePhyUshort(sc, 0x1f, 0x0002);
                 MP_WritePhyUshort(sc, 0x1f, 0x0000);
                 Data = MP_ReadPhyUshort(sc, 0x14);
                 Data |= BIT_15;
@@ -16451,6 +22595,17 @@ static void re_hw_phy_config(struct re_softc *sc)
                 MP_WritePhyUshort(sc, 0x06, Data);
                 MP_WritePhyUshort(sc, 0x1f, 0x0000);
 
+                MP_WritePhyUshort(sc, 0x1F, 0x0004);
+                MP_WritePhyUshort(sc, 0x1F, 0x0007);
+                MP_WritePhyUshort(sc, 0x1E, 0x00AC);
+                MP_WritePhyUshort(sc, 0x18, 0x0006);
+                MP_WritePhyUshort(sc, 0x1F, 0x0002);
+                MP_WritePhyUshort(sc, 0x1F, 0x0000);
+
+                MP_WritePhyUshort(sc, 0x1F, 0x0003);
+                MP_WritePhyUshort(sc, 0x09, 0xA20F);
+                MP_WritePhyUshort(sc, 0x1F, 0x0000);
+
                 MP_WritePhyUshort(sc, 0x1F, 0x0005);
                 MP_WritePhyUshort(sc, 0x05, 0x8B85);
                 Data = MP_ReadPhyUshort(sc, 0x06);
